"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/package/index.ts
var index_exports = {};
__export(index_exports, {
  usePagination: () => usePagination
});
module.exports = __toCommonJS(index_exports);

// src/package/hooks/usePagination/usePagination.ts
var import_react = require("react");

// src/package/utils/generateNumArr/generateNumArr.ts
function generateNumArr(loopStart, loopMax) {
  const numArr = [];
  for (let i = loopStart; i <= loopMax; i++) {
    numArr.push(i);
  }
  return numArr;
}

// src/package/utils/getOffsetNumbers/getOffsetNumbers.ts
function getOffsetNumbers({
  pageNumbers,
  firstNumber,
  lastNumber,
  activeNumber,
  offset,
  permanentFirstNumber,
  permanentLastNumber
}) {
  const pageOffsetNumbers = [];
  if (!firstNumber || !lastNumber) {
    return { pageOffsetNumbers };
  }
  const additionalOffsetStart = firstNumber + offset * 2 + (permanentFirstNumber ? 1 : 0);
  const additionalOffsetEnd = lastNumber - offset * 2 - (permanentLastNumber ? 1 : 0);
  for (const pageNumber of pageNumbers) {
    if (pageNumber === activeNumber || pageNumber <= activeNumber + offset && pageNumber > activeNumber || pageNumber >= activeNumber - offset && pageNumber < activeNumber || activeNumber - offset <= firstNumber && pageNumber <= additionalOffsetStart || activeNumber + offset >= lastNumber && pageNumber >= additionalOffsetEnd) {
      pageOffsetNumbers.push(pageNumber);
    }
  }
  return { pageOffsetNumbers };
}

// src/package/hooks/usePagination/usePagination.ts
function usePagination({
  activePage: initialActivePage,
  recordsPerPage: initialRecordsPerPage,
  totalRecordsLength,
  offset,
  navCustomPageSteps,
  permanentFirstNumber,
  permanentLastNumber
}) {
  const [activePage, setActivePage] = (0, import_react.useState)(initialActivePage);
  const [recordsPerPage, setRecordsPerPage] = (0, import_react.useState)(initialRecordsPerPage);
  const indexOfLastRecord = (recordsPerPage > totalRecordsLength ? totalRecordsLength : activePage * recordsPerPage) - 1;
  const indexOfFirstRecord = recordsPerPage > indexOfLastRecord ? 0 : indexOfLastRecord - recordsPerPage + 1;
  if (totalRecordsLength < 0) {
    throw new Error("totalRecordsLength cannot be negative");
  }
  if (recordsPerPage <= 0) {
    throw new Error("recordsPerPage must be greater than zero");
  }
  if (activePage <= 0) {
    throw new Error("activePage must be at least 1");
  }
  const pageNumbers = (0, import_react.useMemo)(() => generateNumArr(1, Math.ceil(totalRecordsLength / recordsPerPage)), [totalRecordsLength, recordsPerPage]);
  const firstPage = (0, import_react.useMemo)(() => pageNumbers[0], [pageNumbers]);
  const lastPage = (0, import_react.useMemo)(() => pageNumbers[pageNumbers.length - 1], [pageNumbers]);
  const { pageOffsetNumbers } = (0, import_react.useMemo)(
    () => getOffsetNumbers({
      pageNumbers,
      firstNumber: firstPage,
      lastNumber: lastPage,
      activeNumber: activePage,
      offset,
      permanentFirstNumber,
      permanentLastNumber
    }),
    [pageNumbers, firstPage, lastPage, activePage, offset, permanentFirstNumber, permanentLastNumber]
  );
  return {
    records: {
      perPage: recordsPerPage,
      indexOfFirst: indexOfFirstRecord,
      indexOfLast: indexOfLastRecord
    },
    pagination: firstPage && lastPage ? {
      activePage,
      firstPage,
      lastPage,
      previousPage: activePage > firstPage ? activePage - 1 : null,
      nextPage: activePage < lastPage ? activePage + 1 : null,
      customPreviousPage: navCustomPageSteps?.prev && activePage - navCustomPageSteps.prev >= firstPage + 1 ? activePage - navCustomPageSteps.prev : null,
      customNextPage: navCustomPageSteps?.next && activePage + navCustomPageSteps.next <= lastPage - 1 ? activePage + navCustomPageSteps.next : null,
      pageNumbers: pageOffsetNumbers
    } : null,
    setRecordsPerPage: (recordsPerPage2) => {
      setRecordsPerPage(recordsPerPage2);
    },
    setActivePage: (pageNumber) => {
      setActivePage(pageNumber);
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  usePagination
});
