type TPaginationData = {
    readonly records: {
        perPage: number;
        indexOfFirst: number;
        indexOfLast: number;
    };
    readonly pagination: {
        activePage: number;
        firstPage: number;
        lastPage: number;
        previousPage: number | null;
        nextPage: number | null;
        customPreviousPage: number | null;
        customNextPage: number | null;
        pageNumbers: number[];
    } | null;
    readonly setActivePage: (pageNumber: number) => void;
    readonly setRecordsPerPage: (recordsPerPage: number) => void;
};
type TFnOptions = {
    activePage: number;
    recordsPerPage: number;
    totalRecordsLength: number;
    offset: number;
    navCustomPageSteps?: {
        prev?: number;
        next?: number;
    };
    permanentFirstNumber?: boolean;
    permanentLastNumber?: boolean;
};
declare function usePagination({ activePage: initialActivePage, recordsPerPage: initialRecordsPerPage, totalRecordsLength, offset, navCustomPageSteps, permanentFirstNumber, permanentLastNumber, }: TFnOptions): TPaginationData;

export { type TFnOptions, type TPaginationData, usePagination };
